#ifndef OMQUALITYMAPDEFS_H
#define OMQUALITYMAPDEFS_H

#include <f90cxx.h>
#include<vector>
#include "Dal.h"


#include "OmSourceParameters.h"







void checkFileExists( string file);

void modifyQualityArray(string inSet, string outSet);


void setQualityImagePixels(string inSet, string outSet);

void createQualityMap(string inSet, string outSet);

void setQualityImagePixels( vector<vector<float> > &image, 
                            vector<vector<int16> > &qualityImage, 
                            vector<OmSourceParameter> &source,
			    int x0, int y0, int binX);

void modifyQualityList(string inSet, string outSet, 
		       vector<double> &ra,
                       vector<double> &dec,
                       vector<int16> &qualityList);


void updateTheQualityList(string inSet, string outSet, string srcListSet);


void ConvertCoordsToFullFrame(float xCoord, float yCoord, int x0, int y0, 
     int xBin, int yBin, float & xOut, float &yOut);


void setCentralRegionPixels( const int x0, const int y0, const int binX, 
              vector<vector<int16> > & image);

void setCornerPixels( const int x0, const int y0, const int binX, vector<vector<int16> > & image);

void setReadOutStreaks( const int binX, vector<vector<int16> > & image);



/***********************************************************
*
*
***********************************************************/
void checkPixels(int nx, int ny, int j, int k, int noFlags, 
		 vector<vector<int16> > &qualityImage, int16 &source);





F90MODPROCPROTO( void, convert_mod, convert1)(double *, double *, double *, double*, double *, double *);
F90MODPROCPROTO( void, convert_mod, convert2)(double *, double *, double *, double*, double *, double *);


F90MODPROCPROTO( int, flags_mod, getnoqualityflags)();
F90MODPROCPROTO( void, flags_mod, getqualityflag)(int *, int *, char[200]);



F90MODPROCPROTO(void, addflags_mod, addsourceflags)(int *, OmSourceParameter *, int *, int *, int *);

F90MODPROCPROTO( void, addflags_mod, createqualitymap)(int16*, int16*);

F90MODPROCPROTO( void, addflags_mod, createimage)(int16*, int16*);

F90MODPROCPROTO( void, addflags_mod, deleteimage)();

F90MODPROCPROTO( void, addflags_mod, deletequalitymap)();


F90MODPROCPROTO(int16, addflags_mod, getqualitypixel)(int16 *, int16*);

F90MODPROCPROTO(void, addflags_mod, setqualitypixel)(int16*, int16*, int16*);



    

void setEdgePixels( int binX, vector<vector<int16> > &qualityImage);


#endif
