#ifndef QUALITYPIXELS_H
#define QUALITYPIXELS_H
#include "Dal.h"
#include <vector>


/**************************************************************
*
*
*
**************************************************************/

class SetQualityPixels
{

public:
    virtual void setPixels( double x, double y, int16 qualityFlag, 
                          vector<vector<int16>  >  &image) = 0; 
    SetQualityPixels() {};
    SetQualityPixels(int k) : binAxis(k) {};
protected: 
    int binAxis;
    int bitNo;
};


/**************************************************************
*
*
*
**************************************************************/
class SetQualityPixels0 : public SetQualityPixels
{

public:
    SetQualityPixels0(int k) : SetQualityPixels(k) { bitNo = 0;};
    virtual void setPixels( double x, double y, int16 qualityFlag, 
                          vector<vector<int16> >  &image);

};



/**************************************************************
*
*
*
**************************************************************/


class SetQualityPixels1 : public SetQualityPixels
{

public:
    SetQualityPixels1(int k) : SetQualityPixels(k) {bitNo = 1;};
    virtual void setPixels( double x, double y, int16 qualityFlag, 
                          vector<vector<int16> >  &image);

 
};



/**************************************************************
*
*
*
**************************************************************/



class SetQualityPixels2 : public SetQualityPixels
{

public:
    SetQualityPixels2(int k) : SetQualityPixels(k) {bitNo = 2;};
    virtual void setPixels( double x, double y, int16 qualityFlag, 
                          vector<vector<int16> >  &image);

 

};


/**************************************************************
*
*
*
**************************************************************/


class SetQualityPixels3 : public SetQualityPixels
{

public:
    SetQualityPixels3(int k) : SetQualityPixels(k) {bitNo = 3;};
    virtual void setPixels( double x, double y, int16 qualityFlag, 
                          vector<vector<int16> >  &image);

 
};


/**************************************************************
*
*
*
**************************************************************/


class SetQualityPixels4 : public SetQualityPixels
{

public:
    SetQualityPixels4(int k) : SetQualityPixels(k) {bitNo = 4;};
    virtual void setPixels( double x, double y, int16 qualityFlag, 
                          vector<vector<int16> >  &image);

 
};


/**************************************************************
*
*
*
**************************************************************/



class SetQualityPixels5 : public SetQualityPixels
{

public:
    SetQualityPixels5(int k) : SetQualityPixels(k) {bitNo = 5;};
    virtual void setPixels( double x, double y, int16 qualityFlag, 
                          vector<vector<int16> >  &image);


};


void dilateImage( vector<vector<int16> > & qualityImage, int bitNumber, int dk);

#endif






